clear all;
clc;
  fh=findall(0,'type','figure');
for i=1:length(fh)
     close(fh(i));
end

% Simulation

% 1. initial setup

n       = 1000;       % number of trial           
i       = zeros(n,1); % market rate (Y axis)
epsilon = [-49.9:0.1:50.0]';% %%%%zeros(n,1);
R       = 100;       % reserve target
T       = zeros(n,1); % intended reserve balance
pro_cum = zeros(n,1); % F(R-T)
i_star  = 0.03;       % Bank Rate
s       = 0.0025;       % spread


% Figure 2

a=1;
for t=1:n;
    pro_cum(t)= normcdf(epsilon(t),0,10*(1+a)); 
    i(t) = i_star - s +2*s*pro_cum(t);
    T(t) = R-epsilon(t); 
    t=t+1;
end
figure
plot(T,i);% demand curve
hold on;


a=0;
for t=1:n;
    pro_cum(t)= normcdf(epsilon(t),0,10*(1+a)); 
    i(t) = i_star - s +2*s*pro_cum(t);
    T(t) = R-epsilon(t); 
    t=t+1;
end
plot(T,i,'Color','red','LineWidth',0.001, 'LineStyle','--');% demand curve
hold off;




% Figure 3   

a=0.1;
n2=10000;

i_mt = zeros(n2,1);
for t=1:n2;
    T_mt(t)= random('Normal',100,5,1,1);% drawing supply T from N(1000,100)
    i_mt(t)= i_star - s +s*normcdf((1+a)*R-T_mt(t),0,10)...
             + s*normcdf((1-a)*R-T_mt(t),0,10); % plugging into i (demand curve SD);
    t=t+1;
end
figure
hist(i_mt,100);  % for CB shock is 1/2 of Demand shock

i_mt2 = zeros(n2,1);
for t=1:n2;
    T_mt2(t)= random('Normal',100,1,1,1);% drawing supply T from N(1000,100)
    i_mt2(t)= i_star - s +s*normcdf((1+a)*R-T_mt2(t),0,10)...
             + s*normcdf((1-a)*R-T_mt2(t),0,10); % plugging into i (demand curve SD);
    t=t+1;
end
figure
hist(i_mt2,100);  % for CB shock is 1/10 of Demand shock

%STDcol=[std(i_mt) std(i_mt2)]

% Figure 4 


i_m = zeros(n2,1);
for t=1:n2;
    T_m(t)= random('Normal',100,5,1,1);% drawing supply T from N(100,10)
    i_m(t)= i_star - s +2*s*normcdf(R-T_m(t),0,10); % plugging into i (demand curve SD);
    t=t+1;
end
figure
hist(i_m,100);  % for CB shock is 1/2 of Demand shock

i_m2 = zeros(n2,1);
for t=1:n2;
    T_m2(t)= random('Normal',100,1,1,1);% drawing supply T from N(1000,100)
    i_m2(t)= i_star - s +2*s*normcdf(R-T_m2(t),0,10); % plugging into i (demand curve SD);
    t=t+1;
end
figure
hist(i_m2,100);  % for CB shock is 1/10 of Demand shock


% Figure 5

n3=100;
a=0:0.01:0.99;
stacked_std = zeros(n3,1);
for rep=1:n3;
i_mt2 = zeros(n2,1);
for t=1:n2;
    T_mt2(t)= random('Normal',100,5,1,1);% drawing supply T from N(100,5)
    i_mt2(t)= i_star - s +s*normcdf((1+a(rep))*R-T_mt2(t),0,10)...
             + s*normcdf((1-a(rep))*R-T_mt2(t),0,10); % plugging into i (demand curve SD);
    t=t+1;
end
stacked_std(rep)=std(i_mt2);
rep=rep+1;
end
figure
plot(a, stacked_std)

% So now we can contruct the volatility of interest rates wrt the level of target range 
vol_mir = [a' stacked_std];


n3=100;
a=0:0.01:0.99;
stacked_std = zeros(n3,1);
for rep=1:n3;
i_mt2 = zeros(n2,1);
for t=1:n2;
    T_mt2(t)= random('Normal',100,1,1,1);% drawing supply T from N(100,1)
    i_mt2(t)= i_star - s +s*normcdf((1+a(rep))*R-T_mt2(t),0,10)...
             + s*normcdf((1-a(rep))*R-T_mt2(t),0,10); % plugging into i (demand curve SD);
    t=t+1;
end
stacked_std(rep)=std(i_mt2);
rep=rep+1;
end
figure
plot(a, stacked_std)

% So now we can contruct the volatility of interest rates wrt the level of target range 
vol_mir = [a' stacked_std];


% Figure 11

% LOAD DATA 

% From 11 May 2006 to the end of May 2007 
load 060511to070531.mat

i_m =data_1y(:,1);
i_star = data_1y(:,2);
i_gap = (i_m - i_star);
[n,c]=size(i_m); % number of sample

s_D=0.25;s=s_D;   % This is s_D = s_L
%s_L=0.25;
F_RT=zeros(n,1);
stigma=zeros(n,1);

t=100; % number of simulation
ThreeDdata = zeros(100,2,t);
for j=1:t; % start the repetition

% DRAW AN EMPIRICAL DISTRIBUTION

for i=1:n
r = pearsrnd(0,std(i_gap),0,3,n,1);% normal distribution
countnega_norm(i)=sum(r<0);
F_RT(i)=countnega_norm(i) / n;
stigma(i)=(i_gap(i) + s_D)/ F_RT(i) - 2*s_D;
i=i+1;
end

% 4. Now calculate stigma distribution

%figure
[fx1,x1]=ksdensity(stigma);

hold on
plot(x1,fx1, 'Color','blue','LineWidth',0.001)
%area(x1,fx1, 'FaceColor','blue')
x1=x1'; fx1=fx1';
ThreeDdata(:,1,j) = x1;
ThreeDdata(:,2,j) = fx1;
Stigma(:,j)=stigma;


%----------
j=j+1;
end; %end of repetition
hold off;


% LOAD DATA 

% From 11 May 2006 to the end of September 2008 
load 060511to080912.mat


i_m =data_1y(:,1);
i_star = data_1y(:,2);
i_gap = (i_m - i_star);
[n,c]=size(i_m); % number of sample

s_D=0.25;s=s_D;   % This is s_D = s_L
s_L=0.25;
F_RT=zeros(n,1);
stigma=zeros(n,1);

t=100; % number of simulation
ThreeDdata = zeros(100,2,t);
for j=1:t; % start the repetition

% DRAW AN EMPIRICAL DISTRIBUTION

for i=1:n
r = pearsrnd(0,std(i_gap),0,3,n,1);% normal distribution
countnega_norm(i)=sum(r<0);
F_RT(i)=countnega_norm(i) / n;
stigma(i)=(i_gap(i) + s_D)/ F_RT(i) - 2*s_D;
i=i+1;
end

% 4. Now calculate stigma distribution

%figure
[fx1,x1]=ksdensity(stigma);

hold on
plot(x1,fx1, 'Color','red','LineWidth',0.001)
%area(x1,fx1, 'FaceColor','blue')
x1=x1'; fx1=fx1';
ThreeDdata(:,1,j) = x1;
ThreeDdata(:,2,j) = fx1;
Stigma(:,j)=stigma;


%----------
j=j+1;
end; %end of repetition
hold off;